image: node:8.11-alpine

stages:
- test
- publish

variables:
  NPM_REGISTRY: "//registry.npmjs.org"

test:
  stage: test
  before_script:
  - npm install
  - npm run build
  script:
  - npm test

publish:
  stage: publish
  only: [tags]
  before_script:
  - echo "${NPM_REGISTRY}/:_authToken=${NPM_TOKEN}" > ~/.npmrc
  - npm install -g replace-in-file
  - replace-in-file "0.0.0-version-placeholder" "${CI_COMMIT_TAG}" package.json
  - npm install
  - npm run build
  script:
  - npm publish --access=public
